(* func_types_annotated.ml : func defs with explicit type annotations *)
open Printf;;

(* Annotate only the arguments *)
let do_math (x : int) (y : int) =   
  let z = x + y in
  let w = z*z + z in
  w;;

(* Annotate args and function return *)
let do_english (s : string) : string =
  let suffix = "-alicious" in
  s^suffix;;

(* Annotate args and function return *)
let repeat_alt_print (n:int) (str1:string) (str2:string) : unit =
  for i=1 to n do
    if i mod 2 = 1 then
      printf "%s\n" str1
    else
      printf "%s\n" str2
  done;;
