(* swap_0_1.ml : function with 
   interesting type signature *)

let swap_0_1 arr =                
  if Array.length arr >= 2 then
    begin
      let x = arr.(0) in
      let y = arr.(1) in
      arr.(0) <- y;
      arr.(1) <- x;
    end;
;;

(* Explicit type annotations shown below  *)

(* swap first two elems in an array *)
let swap_0_1 (arr : 'a array) : unit = 
(*            any array type   return *)
  if Array.length arr >= 2 then
    begin                   (* begin a "block" within if *)
      let x = arr.(0) in
      let y = arr.(1) in
      arr.(0) <- y;         (* begin required as multiple *)
      arr.(1) <- x;         (* side-effects are performed *)
    end;                    (* last statement is assignment so *)
;;                          (* function returns unit *)
