(* count_times.ml : polymorphic counting function *)

(* count number of times elem appears in array arr *)
let count_times elem arr =
  let count = ref 0 in          (* ref to count *)
  let len = Array.length arr in (* array length *)
  for i=0 to len-1 do
    if arr.(i) = elem then      (* check for equal elem *)
      count := !count  + 1      (* update count if equal *)
      (* incr count; *)         (* increments an in ref *)
  done;
  !count                        (* deref count and return *)
;;
