(* ref_errors_fixed.ml : corrected errors with refs *)
let ipow x n =        (* calculate x to the nth power *)
  let p = ref 1 in
  for i=1 to n do
    p := !p * n;      (* 1st error: get contents of p to multiply *)
  done;
  !p                  (* 2nd error: return contents, not ref itself *)
;;
(* File "ref_errors.ml", line 4, characters 9-10:
   Error: This expression has type int ref
         but an expression was expected of type int *)

let sum = (ipow 2 5) + (ipow 3 7);;
(* File "ref_errors.ml", line 12, characters 10-20:
   Error: This expression has type int ref
          but an expression was expected of type int *)

Printf.printf "sum is %d\n" sum;;
